(function($) {
    'use strict';
    
    var $window = $(window);
    var $document = $(document);
    var $backToTopContainer = $('.cbtt-back-to-top-container');
    var $backToTopButton = $('.cbtt-back-to-top-button');
    var $circlePath = $('.cbtt-circle-path');
    var circlePathLength = $circlePath.length ? $circlePath[0].getTotalLength() : 283;
    var scrollThreshold = 300;
    var isVisible = false;
    
    function init() {
        if ($circlePath.length) {
            $circlePath.css({
                'stroke-dasharray': circlePathLength,
                'stroke-dashoffset': circlePathLength
            });
        }
        
        $window.on('scroll', handleScroll);
        $backToTopButton.on('click', scrollToTop);
    }
    
    function handleScroll() {
        var scrollTop = $window.scrollTop();
        var documentHeight = $document.height();
        var windowHeight = $window.height();
        var scrollPercentage = scrollTop / (documentHeight - windowHeight);
        
        updateProgress(scrollPercentage);
        
        if (scrollTop > scrollThreshold && !isVisible) {
            $backToTopContainer.addClass('cbtt-visible');
            isVisible = true;
        } else if (scrollTop <= scrollThreshold && isVisible) {
            $backToTopContainer.removeClass('cbtt-visible');
            isVisible = false;
        }
    }
    
    function updateProgress(percentage) {
        if ($circlePath.length && cbttOptions.gauge_enabled === 'yes') {
            var dashOffset = circlePathLength - (circlePathLength * percentage);
            $circlePath.css('stroke-dashoffset', dashOffset);
        }
    }
    
    function scrollToTop() {
        $('html, body').animate({
            scrollTop: 0
        }, 800);
        return false;
    }
    
    $(document).ready(init);
    
})(jQuery);