<?php
/*
Plugin Name: スクロールインジケーター付き戻るボタン
Plugin URI: https://dodon.me/plugin/circular-back-to-top/
Description: カラーや位置のカスタマイズが可能な、スクロール進捗インジケーター付きのトップへ戻るボタンを追加します。
Version: 1.0
Author: dodon
Author URI: https://dodon.me/
Text Domain: circular-back-to-top
*/

if (!defined('ABSPATH')) {
    exit;
}

define('CBTT_PLUGIN_DIR', plugin_dir_path(__FILE__));
define('CBTT_PLUGIN_URL', plugin_dir_url(__FILE__));
define('CBTT_PLUGIN_VERSION', '1.0');

require_once CBTT_PLUGIN_DIR . 'includes/class-cbtt-settings.php';
require_once CBTT_PLUGIN_DIR . 'includes/class-cbtt-public.php';

function cbtt_init() {
    $cbtt_settings = new CBTT_Settings();
    $cbtt_settings->init();
    
    $cbtt_public = new CBTT_Public();
    $cbtt_public->init();
}
add_action('plugins_loaded', 'cbtt_init');

function cbtt_activate() {
    $defaults = array(
        'position' => 'right',
        'button_color' => '#3498db',
        'arrow_color' => '#ffffff',
        'gauge_enabled' => 'yes',
        'gauge_color' => '#2ecc71'
    );
    
    if (!get_option('cbtt_options')) {
        add_option('cbtt_options', $defaults);
    }
}
register_activation_hook(__FILE__, 'cbtt_activate');

function cbtt_deactivate() {
}
register_deactivation_hook(__FILE__, 'cbtt_deactivate');